---
title: ServiceWorkerMessageEvent.source
slug: Web/API/ServiceWorkerMessageEvent/source
tags:
  - API
  - Deprecated
  - Experimental
  - Property
  - Reference
  - Service Workers
  - ServiceWorkerMessageEvent
  - source
---
<p>{{APIRef("Service Workers API")}}{{deprecated_header}}</p>

<div class="warning">
<p><strong>Important</strong>: In modern browsers, this property has been deprecated. Service worker messages will now use the {{domxref("MessageEvent")}} interface, for consistency with other web messaging features.</p>
</div>

<p>The <font face="Consolas, Liberation Mono, Courier, monospace"><strong>source</strong></font> read-only property of the {{domxref("ServiceWorkerMessageEvent")}} returns a reference to the {{domxref("ServiceWorker")}} object of the associated service worker that sent the message.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var mySource = ServiceWorkerMessageEventInstance.source;</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("ServiceWorker")}} or {{domxref("MessagePort")}} object.</p>

<h2 id="Examples">Examples</h2>

<p>When the following code is used inside the main thread to set up a message channel between it and a service worker for sending messages between the two, the event object of <code>onmessage</code> will be a <code>ServiceWorkerMessageEvent</code>.</p>

<pre class="brush: js">navigator.serviceWorker.ready.then(function(reg) {

  ...

      // set up a message channel to communicate with the SW
      var channel = new MessageChannel();
      channel.port1.onmessage = function(e) {
        console.log(e.source);
        handleChannelMessage(e.data);
      }

      mySW = reg.active;
      mySW.postMessage('hello', [channel.port2]);
  });</pre>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ServiceWorkerMessageEvent.source")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/ServiceWorker_API/Using_Service_Workers">Using Service Workers</a></li>
 <li><a class="external external-icon" href="https://github.com/mdn/sw-test">Service workers basic code example</a></li>
 <li><a class="external external-icon" href="https://jakearchibald.github.io/isserviceworkerready/">Is ServiceWorker ready?</a></li>
 <li><a href="/en-US/docs/Web/API/Channel_Messaging_API">Channel Messaging</a></li>
</ul>
